/**
 * Bricks integration with the Rank Math plugin
 */
let bricksContentData = ''

function getBricksContentData(e) {
	return bricksContentData
}

function updateContentData() {
	jQuery.ajax({
		url: window.bricksRankMath.ajaxUrl,
		type: 'POST',
		data: {
			action: 'bricks_get_html_from_content',
			nonce: window.bricksRankMath.nonce,
			postId: window.bricksRankMath.postId
		},
		success: function (res) {
			if (res.data.html) {
				bricksContentData = res.data.html

				// Trigger Rank Math to update content (using the hook)
				rankMathEditor.refresh('content')
			}
		}
	})
}

//TODO: to be used inside the builder when content is saved
function bricksRankMathAddContent(event) {
	// Payload of custom event
	let data = event.detail

	jQuery.ajax({
		url: window.bricksRankMath.ajaxUrl,
		type: 'POST',
		data: {
			action: 'bricks_get_html_from_content',
			nonce: window.bricksRankMath.nonce,
			content: JSON.stringify(data.content),
			postId: window.bricksRankMath.postId
		},
		success: (res) => {
			if (res.data.html) {
				wp.hooks.addFilter('rank_math_content', 'rank-math', res.data.html)
			}
		}
	})
}

// On 'post.php' admin screen update Rank Math with the builder content
document.addEventListener('DOMContentLoaded', function (e) {
	if (!window.bricksRankMath || !window.bricksRankMath.renderWithBricks) {
		return
	}

	// Hook on Rank Math content filter
	wp.hooks.addFilter('rank_math_content', 'bricks', getBricksContentData)

	// Fetch content
	updateContentData()
})

// TODO: Hook on Bricks builder save
document.addEventListener('bricksContentSaved', function (e) {
	//bricksRankMathAddContent(e)
})
